#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspfetidpsetpressureoperator_ KSPFETIDPSETPRESSUREOPERATOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspfetidpsetpressureoperator_ kspfetidpsetpressureoperator
#endif
PETSC_EXTERN void kspfetidpsetpressureoperator_(KSP *a, Mat *b, PetscErrorCode *ierr)
{
  *ierr = KSPFETIDPSetPressureOperator(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspfetidpgetinnerksp_ KSPFETIDPGETINNERKSP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspfetidpgetinnerksp_ kspfetidpgetinnerksp
#endif
PETSC_EXTERN void kspfetidpgetinnerksp_(KSP *a, KSP *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = KSPFETIDPGetInnerKSP(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspfetidpgetinnerbddc_ KSPFETIDPGETINNERBDDC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspfetidpgetinnerbddc_ kspfetidpgetinnerbddc
#endif
PETSC_EXTERN void kspfetidpgetinnerbddc_(KSP *a, PC *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = KSPFETIDPGetInnerBDDC(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscksp.h>
#include <petscksp.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspfetidpsetinnerbddc_ KSPFETIDPSETINNERBDDC
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspfetidpsetinnerbddc_ kspfetidpsetinnerbddc
#endif
PETSC_EXTERN void kspfetidpsetinnerbddc_(KSP *a, PC *b, PetscErrorCode *ierr)
{
  *ierr = KSPFETIDPSetInnerBDDC(*a, *b);
  if (*ierr) return;
}
