#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tsalphasetradius_ TSALPHASETRADIUS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tsalphasetradius_ tsalphasetradius
#endif
PETSC_EXTERN void tsalphasetradius_(TS *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TSAlphaSetRadius(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tsalphasetparams_ TSALPHASETPARAMS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tsalphasetparams_ tsalphasetparams
#endif
PETSC_EXTERN void tsalphasetparams_(TS *a, PetscReal *b, PetscReal *c, PetscReal *d, PetscErrorCode *ierr)
{
  *ierr = TSAlphaSetParams(*a, *b, *c, *d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscts.h>
#include <petscts.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define tsalphagetparams_ TSALPHAGETPARAMS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define tsalphagetparams_ tsalphagetparams
#endif
PETSC_EXTERN void tsalphagetparams_(TS *a, PetscReal *b, PetscReal *c, PetscReal *d, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  CHKFORTRANNULLREAL(c);
  CHKFORTRANNULLREAL(d);
  *ierr = TSAlphaGetParams(*a, b, c, d);
  if (*ierr) return;
}
