#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspmonitorsnesresidual_ KSPMONITORSNESRESIDUAL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspmonitorsnesresidual_ kspmonitorsnesresidual
#endif
PETSC_EXTERN void kspmonitorsnesresidual_(KSP *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = KSPMonitorSNESResidual(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define kspmonitorsnesresidualdrawlg_ KSPMONITORSNESRESIDUALDRAWLG
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define kspmonitorsnesresidualdrawlg_ kspmonitorsnesresidualdrawlg
#endif
PETSC_EXTERN void kspmonitorsnesresidualdrawlg_(KSP *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = KSPMonitorSNESResidualDrawLG(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorsolution_ SNESMONITORSOLUTION
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorsolution_ snesmonitorsolution
#endif
PETSC_EXTERN void snesmonitorsolution_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorSolution(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorresidual_ SNESMONITORRESIDUAL
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorresidual_ snesmonitorresidual
#endif
PETSC_EXTERN void snesmonitorresidual_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorResidual(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorsolutionupdate_ SNESMONITORSOLUTIONUPDATE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorsolutionupdate_ snesmonitorsolutionupdate
#endif
PETSC_EXTERN void snesmonitorsolutionupdate_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorSolutionUpdate(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitordefaultsetup_ SNESMONITORDEFAULTSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitordefaultsetup_ snesmonitordefaultsetup
#endif
PETSC_EXTERN void snesmonitordefaultsetup_(SNES *a, PetscViewerAndFormat *b, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorDefaultSetUp(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitordefault_ SNESMONITORDEFAULT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitordefault_ snesmonitordefault
#endif
PETSC_EXTERN void snesmonitordefault_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorDefault(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorscaling_ SNESMONITORSCALING
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorscaling_ snesmonitorscaling
#endif
PETSC_EXTERN void snesmonitorscaling_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorScaling(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorjacupdatespectrum_ SNESMONITORJACUPDATESPECTRUM
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorjacupdatespectrum_ snesmonitorjacupdatespectrum
#endif
PETSC_EXTERN void snesmonitorjacupdatespectrum_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorJacUpdateSpectrum(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorrange_ SNESMONITORRANGE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorrange_ snesmonitorrange
#endif
PETSC_EXTERN void snesmonitorrange_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorRange(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorratio_ SNESMONITORRATIO
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorratio_ snesmonitorratio
#endif
PETSC_EXTERN void snesmonitorratio_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorRatio(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitorratiosetup_ SNESMONITORRATIOSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitorratiosetup_ snesmonitorratiosetup
#endif
PETSC_EXTERN void snesmonitorratiosetup_(SNES *a, PetscViewerAndFormat *b, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorRatioSetUp(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitordefaultshort_ SNESMONITORDEFAULTSHORT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitordefaultshort_ snesmonitordefaultshort
#endif
PETSC_EXTERN void snesmonitordefaultshort_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorDefaultShort(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesmonitordefaultfield_ SNESMONITORDEFAULTFIELD
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesmonitordefaultfield_ snesmonitordefaultfield
#endif
PETSC_EXTERN void snesmonitordefaultfield_(SNES *a, PetscInt *b, PetscReal *c, PetscViewerAndFormat *d, PetscErrorCode *ierr)
{
  *ierr = SNESMonitorDefaultField(*a, *b, *c, d);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesconvergeddefault_ SNESCONVERGEDDEFAULT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesconvergeddefault_ snesconvergeddefault
#endif
PETSC_EXTERN void snesconvergeddefault_(SNES *a, PetscInt *b, PetscReal *c, PetscReal *d, PetscReal *e, SNESConvergedReason *f, void *g, PetscErrorCode *ierr)
{
  *ierr = SNESConvergedDefault(*a, *b, *c, *d, *e, f, g);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snesconvergedskip_ SNESCONVERGEDSKIP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snesconvergedskip_ snesconvergedskip
#endif
PETSC_EXTERN void snesconvergedskip_(SNES *a, PetscInt *b, PetscReal *c, PetscReal *d, PetscReal *e, SNESConvergedReason *f, void *g, PetscErrorCode *ierr)
{
  *ierr = SNESConvergedSkip(*a, *b, *c, *d, *e, f, g);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petscsnes.h>
#include <petscsnes.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define snessetworkvecs_ SNESSETWORKVECS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define snessetworkvecs_ snessetworkvecs
#endif
PETSC_EXTERN void snessetworkvecs_(SNES *a, PetscInt *b, PetscErrorCode *ierr)
{
  *ierr = SNESSetWorkVecs(*a, *b);
  if (*ierr) return;
}
