#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetmisfithessianchangestatus_ TAOADMMSETMISFITHESSIANCHANGESTATUS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetmisfithessianchangestatus_ taoadmmsetmisfithessianchangestatus
#endif
PETSC_EXTERN void taoadmmsetmisfithessianchangestatus_(Tao *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetMisfitHessianChangeStatus(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetreghessianchangestatus_ TAOADMMSETREGHESSIANCHANGESTATUS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetreghessianchangestatus_ taoadmmsetreghessianchangestatus
#endif
PETSC_EXTERN void taoadmmsetreghessianchangestatus_(Tao *a, PetscBool *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetRegHessianChangeStatus(*a, *b ? PETSC_TRUE : PETSC_FALSE);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetspectralpenalty_ TAOADMMSETSPECTRALPENALTY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetspectralpenalty_ taoadmmsetspectralpenalty
#endif
PETSC_EXTERN void taoadmmsetspectralpenalty_(Tao *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetSpectralPenalty(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetspectralpenalty_ TAOADMMGETSPECTRALPENALTY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetspectralpenalty_ taoadmmgetspectralpenalty
#endif
PETSC_EXTERN void taoadmmgetspectralpenalty_(Tao *a, PetscReal *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  *ierr = TaoADMMGetSpectralPenalty(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetmisfitsubsolver_ TAOADMMGETMISFITSUBSOLVER
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetmisfitsubsolver_ taoadmmgetmisfitsubsolver
#endif
PETSC_EXTERN void taoadmmgetmisfitsubsolver_(Tao *a, Tao *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = TaoADMMGetMisfitSubsolver(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetregularizationsubsolver_ TAOADMMGETREGULARIZATIONSUBSOLVER
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetregularizationsubsolver_ taoadmmgetregularizationsubsolver
#endif
PETSC_EXTERN void taoadmmgetregularizationsubsolver_(Tao *a, Tao *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = TaoADMMGetRegularizationSubsolver(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetconstraintvectorrhs_ TAOADMMSETCONSTRAINTVECTORRHS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetconstraintvectorrhs_ taoadmmsetconstraintvectorrhs
#endif
PETSC_EXTERN void taoadmmsetconstraintvectorrhs_(Tao *a, Vec *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetConstraintVectorRHS(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetminimumspectralpenalty_ TAOADMMSETMINIMUMSPECTRALPENALTY
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetminimumspectralpenalty_ taoadmmsetminimumspectralpenalty
#endif
PETSC_EXTERN void taoadmmsetminimumspectralpenalty_(Tao *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetMinimumSpectralPenalty(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetregularizercoefficient_ TAOADMMSETREGULARIZERCOEFFICIENT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetregularizercoefficient_ taoadmmsetregularizercoefficient
#endif
PETSC_EXTERN void taoadmmsetregularizercoefficient_(Tao *a, PetscReal *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetRegularizerCoefficient(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetregularizercoefficient_ TAOADMMGETREGULARIZERCOEFFICIENT
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetregularizercoefficient_ taoadmmgetregularizercoefficient
#endif
PETSC_EXTERN void taoadmmgetregularizercoefficient_(Tao *a, PetscReal *b, PetscErrorCode *ierr)
{
  CHKFORTRANNULLREAL(b);
  *ierr = TaoADMMGetRegularizerCoefficient(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taogetadmmparenttao_ TAOGETADMMPARENTTAO
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taogetadmmparenttao_ taogetadmmparenttao
#endif
PETSC_EXTERN void taogetadmmparenttao_(Tao *a, Tao *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = TaoGetADMMParentTao(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetdualvector_ TAOADMMGETDUALVECTOR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetdualvector_ taoadmmgetdualvector
#endif
PETSC_EXTERN void taoadmmgetdualvector_(Tao *a, Vec *b, PetscErrorCode *ierr)
{
  PetscBool null_b = !*(void**) b ? PETSC_TRUE : PETSC_FALSE;
  CHKFORTRANNULLOBJECT(b);
  *ierr = TaoADMMGetDualVector(*a, b);
  if (*ierr) return;
  if (! null_b && !*(void**) b) *(void **) b = (void *)-2;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetregularizertype_ TAOADMMSETREGULARIZERTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetregularizertype_ taoadmmsetregularizertype
#endif
PETSC_EXTERN void taoadmmsetregularizertype_(Tao *a, TaoADMMRegularizerType *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetRegularizerType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetregularizertype_ TAOADMMGETREGULARIZERTYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetregularizertype_ taoadmmgetregularizertype
#endif
PETSC_EXTERN void taoadmmgetregularizertype_(Tao *a, TaoADMMRegularizerType *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMGetRegularizerType(*a, b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmsetupdatetype_ TAOADMMSETUPDATETYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmsetupdatetype_ taoadmmsetupdatetype
#endif
PETSC_EXTERN void taoadmmsetupdatetype_(Tao *a, TaoADMMUpdateType *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMSetUpdateType(*a, *b);
  if (*ierr) return;
}
#include "petscsys.h"
#include "petscfix.h"
#include "petsc/private/ftnimpl.h"
#include <petsctao.h>
#include <petsctao.h>
#if defined(PETSC_HAVE_FORTRAN_CAPS)
  #define taoadmmgetupdatetype_ TAOADMMGETUPDATETYPE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE)
  #define taoadmmgetupdatetype_ taoadmmgetupdatetype
#endif
PETSC_EXTERN void taoadmmgetupdatetype_(Tao *a, TaoADMMUpdateType *b, PetscErrorCode *ierr)
{
  *ierr = TaoADMMGetUpdateType(*a, b);
  if (*ierr) return;
}
